diff --git a/example/ipsec/Makefile.am b/example/ipsec/Makefile.am
index c82ea0a..01ccd42 100644
--- a/example/ipsec/Makefile.am
+++ b/example/ipsec/Makefile.am
@@ -15,15 +15,15 @@ noinst_HEADERS = \
 		  $(top_srcdir)/example/example_debug.h
 
 dist_bin_SCRIPTS = \
-		   $(srcdir)/run_ah_in \
-		   $(srcdir)/run_ah_out \
-		   $(srcdir)/run_both_in \
-		   $(srcdir)/run_both_out \
-		   $(srcdir)/run_esp_in \
-		   $(srcdir)/run_esp_out \
-		   $(srcdir)/run_live \
-		   $(srcdir)/run_router \
-		   $(srcdir)/run_simple
+		   $(srcdir)/odp_ipsec_run_ah_in \
+		   $(srcdir)/odp_ipsec_run_ah_out \
+		   $(srcdir)/odp_ipsec_run_both_in \
+		   $(srcdir)/odp_ipsec_run_both_out \
+		   $(srcdir)/odp_ipsec_run_esp_in \
+		   $(srcdir)/odp_ipsec_run_esp_out \
+		   $(srcdir)/odp_ipsec_run_live \
+		   $(srcdir)/odp_ipsec_run_router \
+		   $(srcdir)/odp_ipsec_run_simple
 
 dist_odp_ipsec_SOURCES = odp_ipsec.c \
 			 odp_ipsec_sa_db.c \
diff --git a/example/ipsec/odp_ipsec_run_ah_in b/example/ipsec/odp_ipsec_run_ah_in
new file mode 100755
index 0000000..252f44b
--- /dev/null
+++ b/example/ipsec/odp_ipsec_run_ah_in
@@ -0,0 +1,12 @@
+#!/bin/bash
+#
+# Test input AH
+#  - 2 loop interfaces
+#  - 10 packets
+#  - Specify API mode on command line
+odp_ipsec -i loop1,loop2 \
+-r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
+-p 192.168.222.0/24:192.168.111.0/24:in:ah \
+-a 192.168.222.2:192.168.111.2:md5:300:27f6d123d7077b361662fc6e451f65d8 \
+-s 192.168.222.2:192.168.111.2:loop2:loop1:10:100 \
+-c 2 -m $1
diff --git a/example/ipsec/odp_ipsec_run_ah_out b/example/ipsec/odp_ipsec_run_ah_out
new file mode 100755
index 0000000..9256c07
--- /dev/null
+++ b/example/ipsec/odp_ipsec_run_ah_out
@@ -0,0 +1,12 @@
+#!/bin/bash
+#
+# Test output AH
+#  - 2 loop interfaces
+#  - 10 packets
+#  - Specify API mode on command line
+odp_ipsec -i loop1,loop2 \
+-r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
+-p 192.168.111.0/24:192.168.222.0/24:out:ah \
+-a 192.168.111.2:192.168.222.2:md5:200:a731649644c5dee92cbd9c2e7e188ee6 \
+-s 192.168.111.2:192.168.222.2:loop1:loop2:10:100 \
+-c 2 -m $1
diff --git a/example/ipsec/odp_ipsec_run_both_in b/example/ipsec/odp_ipsec_run_both_in
new file mode 100755
index 0000000..c3f169c
--- /dev/null
+++ b/example/ipsec/odp_ipsec_run_both_in
@@ -0,0 +1,14 @@
+#!/bin/bash
+#
+# Test AH and ESP input
+#  - 2 loop interfaces
+#  - 10 packets
+#  - Specify API mode on command line
+odp_ipsec -i loop1,loop2 \
+-r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
+-p 192.168.222.0/24:192.168.111.0/24:in:both \
+-a 192.168.222.2:192.168.111.2:md5:300:27f6d123d7077b361662fc6e451f65d8 \
+-e 192.168.222.2:192.168.111.2:\
+3des:301:c966199f24d095f3990a320d749056401e82b26570320292 \
+-s 192.168.222.2:192.168.111.2:loop2:loop1:10:100 \
+-c 2 -m $1
diff --git a/example/ipsec/odp_ipsec_run_both_out b/example/ipsec/odp_ipsec_run_both_out
new file mode 100755
index 0000000..8ba0672
--- /dev/null
+++ b/example/ipsec/odp_ipsec_run_both_out
@@ -0,0 +1,14 @@
+#!/bin/bash
+#
+# Test AH and ESP output
+#  - 2 loop interfaces
+#  - 10 packets
+#  - Specify API mode on command line
+odp_ipsec -i loop1,loop2 \
+-r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
+-p 192.168.111.0/24:192.168.222.0/24:out:both \
+-e 192.168.111.2:192.168.222.2:\
+3des:201:656c8523255ccc23a66c1917aa0cf30991fce83532a4b224 \
+-a 192.168.111.2:192.168.222.2:md5:200:a731649644c5dee92cbd9c2e7e188ee6 \
+-s 192.168.111.2:192.168.222.2:loop1:loop2:10:100 \
+-c 2 -m $1
diff --git a/example/ipsec/odp_ipsec_run_esp_in b/example/ipsec/odp_ipsec_run_esp_in
new file mode 100755
index 0000000..12fdae6
--- /dev/null
+++ b/example/ipsec/odp_ipsec_run_esp_in
@@ -0,0 +1,13 @@
+#!/bin/bash
+#
+# Test input ESP
+#  - 2 loop interfaces
+#  - 10 packets
+#  - Specify API mode on command line
+odp_ipsec -i loop1,loop2 \
+-r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
+-p 192.168.222.0/24:192.168.111.0/24:in:esp \
+-e 192.168.222.2:192.168.111.2:\
+3des:301:c966199f24d095f3990a320d749056401e82b26570320292 \
+-s 192.168.222.2:192.168.111.2:loop2:loop1:10:100 \
+-c 2 -m $1
diff --git a/example/ipsec/odp_ipsec_run_esp_out b/example/ipsec/odp_ipsec_run_esp_out
new file mode 100755
index 0000000..73c4ff0
--- /dev/null
+++ b/example/ipsec/odp_ipsec_run_esp_out
@@ -0,0 +1,13 @@
+#!/bin/bash
+#
+# Test output ESP
+#  - 2 loop interfaces
+#  - 10 packets
+#  - Specify API mode on command line
+odp_ipsec -i loop1,loop2 \
+-r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
+-p 192.168.111.0/24:192.168.222.0/24:out:esp \
+-e 192.168.111.2:192.168.222.2:\
+3des:201:656c8523255ccc23a66c1917aa0cf30991fce83532a4b224 \
+-s 192.168.111.2:192.168.222.2:loop1:loop2:10:100 \
+-c 2 -m $1
diff --git a/example/ipsec/odp_ipsec_run_live b/example/ipsec/odp_ipsec_run_live
new file mode 100755
index 0000000..90947ad
--- /dev/null
+++ b/example/ipsec/odp_ipsec_run_live
@@ -0,0 +1,17 @@
+#!/bin/bash
+#
+# Live router test
+#  - 2 interfaces interfaces
+#  - Specify API mode on command line
+sudo odp_ipsec -i p7p1,p8p1 \
+-r 192.168.111.2/32:p7p1:08.00.27.76.B5.E0 \
+-r 192.168.222.2/32:p8p1:08.00.27.F5.8B.DB \
+-p 192.168.111.0/24:192.168.222.0/24:out:both \
+-e 192.168.111.2:192.168.222.2:\
+3des:201:656c8523255ccc23a66c1917aa0cf30991fce83532a4b224 \
+-a 192.168.111.2:192.168.222.2:md5:200:a731649644c5dee92cbd9c2e7e188ee6 \
+-p 192.168.222.0/24:192.168.111.0/24:in:both \
+-e 192.168.222.2:192.168.111.2:\
+3des:301:c966199f24d095f3990a320d749056401e82b26570320292 \
+-a 192.168.222.2:192.168.111.2:md5:300:27f6d123d7077b361662fc6e451f65d8 \
+-c 2 -m $1
diff --git a/example/ipsec/odp_ipsec_run_router b/example/ipsec/odp_ipsec_run_router
new file mode 100755
index 0000000..3630297
--- /dev/null
+++ b/example/ipsec/odp_ipsec_run_router
@@ -0,0 +1,9 @@
+#!/bin/bash
+#
+# Live router test
+#  - 2 interfaces interfaces
+#  - Specify API mode on command line
+sudo odp_ipsec -i p7p1,p8p1 \
+-r 192.168.111.2/32:p7p1:08.00.27.76.B5.E0 \
+-r 192.168.222.2/32:p8p1:08.00.27.F5.8B.DB \
+-c 1 -m $1
diff --git a/example/ipsec/odp_ipsec_run_simple b/example/ipsec/odp_ipsec_run_simple
new file mode 100755
index 0000000..1211583
--- /dev/null
+++ b/example/ipsec/odp_ipsec_run_simple
@@ -0,0 +1,10 @@
+#!/bin/bash
+#
+# Simple router test
+#  - 2 loop interfaces
+#  - 10 packets
+#  - Specify API mode on command line
+odp_ipsec -i loop1,loop2 \
+-r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
+-s 192.168.111.2:192.168.222.2:loop1:loop2:10:100 \
+-c 2 -m $1
diff --git a/example/ipsec/run_ah_in b/example/ipsec/run_ah_in
deleted file mode 100755
index 252f44b..0000000
--- a/example/ipsec/run_ah_in
+++ /dev/null
@@ -1,12 +0,0 @@
-#!/bin/bash
-#
-# Test input AH
-#  - 2 loop interfaces
-#  - 10 packets
-#  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
--r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
--p 192.168.222.0/24:192.168.111.0/24:in:ah \
--a 192.168.222.2:192.168.111.2:md5:300:27f6d123d7077b361662fc6e451f65d8 \
--s 192.168.222.2:192.168.111.2:loop2:loop1:10:100 \
--c 2 -m $1
diff --git a/example/ipsec/run_ah_out b/example/ipsec/run_ah_out
deleted file mode 100755
index 9256c07..0000000
--- a/example/ipsec/run_ah_out
+++ /dev/null
@@ -1,12 +0,0 @@
-#!/bin/bash
-#
-# Test output AH
-#  - 2 loop interfaces
-#  - 10 packets
-#  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
--r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
--p 192.168.111.0/24:192.168.222.0/24:out:ah \
--a 192.168.111.2:192.168.222.2:md5:200:a731649644c5dee92cbd9c2e7e188ee6 \
--s 192.168.111.2:192.168.222.2:loop1:loop2:10:100 \
--c 2 -m $1
diff --git a/example/ipsec/run_both_in b/example/ipsec/run_both_in
deleted file mode 100755
index c3f169c..0000000
--- a/example/ipsec/run_both_in
+++ /dev/null
@@ -1,14 +0,0 @@
-#!/bin/bash
-#
-# Test AH and ESP input
-#  - 2 loop interfaces
-#  - 10 packets
-#  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
--r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
--p 192.168.222.0/24:192.168.111.0/24:in:both \
--a 192.168.222.2:192.168.111.2:md5:300:27f6d123d7077b361662fc6e451f65d8 \
--e 192.168.222.2:192.168.111.2:\
-3des:301:c966199f24d095f3990a320d749056401e82b26570320292 \
--s 192.168.222.2:192.168.111.2:loop2:loop1:10:100 \
--c 2 -m $1
diff --git a/example/ipsec/run_both_out b/example/ipsec/run_both_out
deleted file mode 100755
index 8ba0672..0000000
--- a/example/ipsec/run_both_out
+++ /dev/null
@@ -1,14 +0,0 @@
-#!/bin/bash
-#
-# Test AH and ESP output
-#  - 2 loop interfaces
-#  - 10 packets
-#  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
--r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
--p 192.168.111.0/24:192.168.222.0/24:out:both \
--e 192.168.111.2:192.168.222.2:\
-3des:201:656c8523255ccc23a66c1917aa0cf30991fce83532a4b224 \
--a 192.168.111.2:192.168.222.2:md5:200:a731649644c5dee92cbd9c2e7e188ee6 \
--s 192.168.111.2:192.168.222.2:loop1:loop2:10:100 \
--c 2 -m $1
diff --git a/example/ipsec/run_esp_in b/example/ipsec/run_esp_in
deleted file mode 100755
index 12fdae6..0000000
--- a/example/ipsec/run_esp_in
+++ /dev/null
@@ -1,13 +0,0 @@
-#!/bin/bash
-#
-# Test input ESP
-#  - 2 loop interfaces
-#  - 10 packets
-#  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
--r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
--p 192.168.222.0/24:192.168.111.0/24:in:esp \
--e 192.168.222.2:192.168.111.2:\
-3des:301:c966199f24d095f3990a320d749056401e82b26570320292 \
--s 192.168.222.2:192.168.111.2:loop2:loop1:10:100 \
--c 2 -m $1
diff --git a/example/ipsec/run_esp_out b/example/ipsec/run_esp_out
deleted file mode 100755
index 73c4ff0..0000000
--- a/example/ipsec/run_esp_out
+++ /dev/null
@@ -1,13 +0,0 @@
-#!/bin/bash
-#
-# Test output ESP
-#  - 2 loop interfaces
-#  - 10 packets
-#  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
--r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
--p 192.168.111.0/24:192.168.222.0/24:out:esp \
--e 192.168.111.2:192.168.222.2:\
-3des:201:656c8523255ccc23a66c1917aa0cf30991fce83532a4b224 \
--s 192.168.111.2:192.168.222.2:loop1:loop2:10:100 \
--c 2 -m $1
diff --git a/example/ipsec/run_live b/example/ipsec/run_live
deleted file mode 100755
index 90947ad..0000000
--- a/example/ipsec/run_live
+++ /dev/null
@@ -1,17 +0,0 @@
-#!/bin/bash
-#
-# Live router test
-#  - 2 interfaces interfaces
-#  - Specify API mode on command line
-sudo odp_ipsec -i p7p1,p8p1 \
--r 192.168.111.2/32:p7p1:08.00.27.76.B5.E0 \
--r 192.168.222.2/32:p8p1:08.00.27.F5.8B.DB \
--p 192.168.111.0/24:192.168.222.0/24:out:both \
--e 192.168.111.2:192.168.222.2:\
-3des:201:656c8523255ccc23a66c1917aa0cf30991fce83532a4b224 \
--a 192.168.111.2:192.168.222.2:md5:200:a731649644c5dee92cbd9c2e7e188ee6 \
--p 192.168.222.0/24:192.168.111.0/24:in:both \
--e 192.168.222.2:192.168.111.2:\
-3des:301:c966199f24d095f3990a320d749056401e82b26570320292 \
--a 192.168.222.2:192.168.111.2:md5:300:27f6d123d7077b361662fc6e451f65d8 \
--c 2 -m $1
diff --git a/example/ipsec/run_router b/example/ipsec/run_router
deleted file mode 100755
index 3630297..0000000
--- a/example/ipsec/run_router
+++ /dev/null
@@ -1,9 +0,0 @@
-#!/bin/bash
-#
-# Live router test
-#  - 2 interfaces interfaces
-#  - Specify API mode on command line
-sudo odp_ipsec -i p7p1,p8p1 \
--r 192.168.111.2/32:p7p1:08.00.27.76.B5.E0 \
--r 192.168.222.2/32:p8p1:08.00.27.F5.8B.DB \
--c 1 -m $1
diff --git a/example/ipsec/run_simple b/example/ipsec/run_simple
deleted file mode 100755
index 1211583..0000000
--- a/example/ipsec/run_simple
+++ /dev/null
@@ -1,10 +0,0 @@
-#!/bin/bash
-#
-# Simple router test
-#  - 2 loop interfaces
-#  - 10 packets
-#  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
--r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
--s 192.168.111.2:192.168.222.2:loop1:loop2:10:100 \
--c 2 -m $1