diff --git a/example/ipsec_api/Makefile.am b/example/ipsec_api/Makefile.am
index 14bc5dd66..848683e00 100644
--- a/example/ipsec_api/Makefile.am
+++ b/example/ipsec_api/Makefile.am
@@ -3,22 +3,23 @@ include $(top_srcdir)/example/Makefile.inc
 AM_CPPFLAGS = $(OPENSSL_CPPFLAGS)
 LDADD += $(OPENSSL_LIBS)
 
-bin_PROGRAMS = odp_ipsec
+bin_PROGRAMS = odp_ipsec_api
 
 dist_bin_SCRIPTS = \
-		   $(srcdir)/odp_ipsec_run_ah_in.sh \
-		   $(srcdir)/odp_ipsec_run_ah_out.sh \
-		   $(srcdir)/odp_ipsec_run_ah_tun_in.sh \
-		   $(srcdir)/odp_ipsec_run_ah_tun_out.sh \
-		   $(srcdir)/odp_ipsec_run_esp_in.sh \
-		   $(srcdir)/odp_ipsec_run_esp_out.sh \
-		   $(srcdir)/odp_ipsec_run_esp_tun_in.sh \
-		   $(srcdir)/odp_ipsec_run_esp_tun_out.sh \
-		   $(srcdir)/odp_ipsec_run_live.sh \
-		   $(srcdir)/odp_ipsec_run_router.sh \
-		   $(srcdir)/odp_ipsec_run_simple.sh
+		   $(srcdir)/odp_ipsec_api_run_ah_in.sh \
+		   $(srcdir)/odp_ipsec_api_run_ah_out.sh \
+		   $(srcdir)/odp_ipsec_api_run_ah_tun_in.sh \
+		   $(srcdir)/odp_ipsec_api_run_ah_tun_out.sh \
+		   $(srcdir)/odp_ipsec_api_run_esp_in.sh \
+		   $(srcdir)/odp_ipsec_api_run_esp_out.sh \
+		   $(srcdir)/odp_ipsec_api_run_esp_tun_in.sh \
+		   $(srcdir)/odp_ipsec_api_run_esp_tun_out.sh \
+		   $(srcdir)/odp_ipsec_api_run_live.sh \
+		   $(srcdir)/odp_ipsec_api_run_router.sh \
+		   $(srcdir)/odp_ipsec_api_run_simple.sh
 
-odp_ipsec_SOURCES = odp_ipsec.c \
+odp_ipsec_api_SOURCES = \
+		    odp_ipsec.c \
 		    odp_ipsec_sa_db.c \
 		    odp_ipsec_sa_db.h \
 		    odp_ipsec_sp_db.c \
diff --git a/example/ipsec_api/odp_ipsec_run_ah_in.sh b/example/ipsec_api/odp_ipsec_api_run_ah_in.sh
similarity index 91%
rename from example/ipsec_api/odp_ipsec_run_ah_in.sh
rename to example/ipsec_api/odp_ipsec_api_run_ah_in.sh
index c5b105f59..becfc8928 100755
--- a/example/ipsec_api/odp_ipsec_run_ah_in.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_ah_in.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
+odp_ipsec_api -i loop1,loop2 \
 -r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
 -p 192.168.222.0/24:192.168.111.0/24:in:ah \
 -a 192.168.222.2:192.168.111.2:md5:300:27f6d123d7077b361662fc6e451f65d8 \
diff --git a/example/ipsec_api/odp_ipsec_run_ah_out.sh b/example/ipsec_api/odp_ipsec_api_run_ah_out.sh
similarity index 91%
rename from example/ipsec_api/odp_ipsec_run_ah_out.sh
rename to example/ipsec_api/odp_ipsec_api_run_ah_out.sh
index c8926d5ac..023809a18 100755
--- a/example/ipsec_api/odp_ipsec_run_ah_out.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_ah_out.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
+odp_ipsec_api -i loop1,loop2 \
 -r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
 -p 192.168.111.0/24:192.168.222.0/24:out:ah \
 -a 192.168.111.2:192.168.222.2:md5:200:a731649644c5dee92cbd9c2e7e188ee6 \
diff --git a/example/ipsec_api/odp_ipsec_run_ah_tun_in.sh b/example/ipsec_api/odp_ipsec_api_run_ah_tun_in.sh
similarity index 92%
rename from example/ipsec_api/odp_ipsec_run_ah_tun_in.sh
rename to example/ipsec_api/odp_ipsec_api_run_ah_tun_in.sh
index a0d4c4332..40c488f04 100755
--- a/example/ipsec_api/odp_ipsec_run_ah_tun_in.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_ah_tun_in.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
+odp_ipsec_api -i loop1,loop2 \
 -r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
 -p 192.168.222.0/24:192.168.111.0/24:in:ah \
 -a 192.168.222.2:192.168.111.2:md5:300:27f6d123d7077b361662fc6e451f65d8 \
diff --git a/example/ipsec_api/odp_ipsec_run_ah_tun_out.sh b/example/ipsec_api/odp_ipsec_api_run_ah_tun_out.sh
similarity index 92%
rename from example/ipsec_api/odp_ipsec_run_ah_tun_out.sh
rename to example/ipsec_api/odp_ipsec_api_run_ah_tun_out.sh
index 74a0e3b42..d7118586f 100755
--- a/example/ipsec_api/odp_ipsec_run_ah_tun_out.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_ah_tun_out.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
+odp_ipsec_api -i loop1,loop2 \
 -r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
 -p 192.168.111.0/24:192.168.222.0/24:out:ah \
 -a 192.168.111.2:192.168.222.2:md5:200:a731649644c5dee92cbd9c2e7e188ee6 \
diff --git a/example/ipsec_api/odp_ipsec_run_esp_in.sh b/example/ipsec_api/odp_ipsec_api_run_esp_in.sh
similarity index 91%
rename from example/ipsec_api/odp_ipsec_run_esp_in.sh
rename to example/ipsec_api/odp_ipsec_api_run_esp_in.sh
index 39e171cdf..cdb302ef4 100755
--- a/example/ipsec_api/odp_ipsec_run_esp_in.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_esp_in.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
+odp_ipsec_api -i loop1,loop2 \
 -r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
 -p 192.168.222.0/24:192.168.111.0/24:in:esp \
 -e 192.168.222.2:192.168.111.2:\
diff --git a/example/ipsec_api/odp_ipsec_run_esp_out.sh b/example/ipsec_api/odp_ipsec_api_run_esp_out.sh
similarity index 92%
rename from example/ipsec_api/odp_ipsec_run_esp_out.sh
rename to example/ipsec_api/odp_ipsec_api_run_esp_out.sh
index 98ab04e52..f1c15ffee 100755
--- a/example/ipsec_api/odp_ipsec_run_esp_out.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_esp_out.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
+odp_ipsec_api -i loop1,loop2 \
 -r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
 -p 192.168.111.0/24:192.168.222.0/24:out:esp \
 -e 192.168.111.2:192.168.222.2:\
diff --git a/example/ipsec_api/odp_ipsec_run_esp_tun_in.sh b/example/ipsec_api/odp_ipsec_api_run_esp_tun_in.sh
similarity index 92%
rename from example/ipsec_api/odp_ipsec_run_esp_tun_in.sh
rename to example/ipsec_api/odp_ipsec_api_run_esp_tun_in.sh
index 7ef3e2d08..5d78479e4 100755
--- a/example/ipsec_api/odp_ipsec_run_esp_tun_in.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_esp_tun_in.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
+odp_ipsec_api -i loop1,loop2 \
 -r 192.168.111.2/32:loop1:08.00.27.76.B5.E0 \
 -p 192.168.222.0/24:192.168.111.0/24:in:esp \
 -e 192.168.222.2:192.168.111.2:\
diff --git a/example/ipsec_api/odp_ipsec_run_esp_tun_out.sh b/example/ipsec_api/odp_ipsec_api_run_esp_tun_out.sh
similarity index 92%
rename from example/ipsec_api/odp_ipsec_run_esp_tun_out.sh
rename to example/ipsec_api/odp_ipsec_api_run_esp_tun_out.sh
index 98ab04e52..f1c15ffee 100755
--- a/example/ipsec_api/odp_ipsec_run_esp_tun_out.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_esp_tun_out.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
+odp_ipsec_api -i loop1,loop2 \
 -r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
 -p 192.168.111.0/24:192.168.222.0/24:out:esp \
 -e 192.168.111.2:192.168.222.2:\
diff --git a/example/ipsec_api/odp_ipsec_run_live.sh b/example/ipsec_api/odp_ipsec_api_run_live.sh
similarity index 94%
rename from example/ipsec_api/odp_ipsec_run_live.sh
rename to example/ipsec_api/odp_ipsec_api_run_live.sh
index b506b2af8..9bc0a60f3 100755
--- a/example/ipsec_api/odp_ipsec_run_live.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_live.sh
@@ -3,7 +3,7 @@
 # Live router test
 #  - 2 interfaces interfaces
 #  - Specify API mode on command line
-sudo odp_ipsec -i p7p1,p8p1 \
+sudo odp_ipsec_api -i p7p1,p8p1 \
 -r 192.168.111.2/32:p7p1:08.00.27.76.B5.E0 \
 -r 192.168.222.2/32:p8p1:08.00.27.F5.8B.DB \
 -p 192.168.111.0/24:192.168.222.0/24:out:both \
diff --git a/example/ipsec_api/odp_ipsec_run_router.sh b/example/ipsec_api/odp_ipsec_api_run_router.sh
similarity index 85%
rename from example/ipsec_api/odp_ipsec_run_router.sh
rename to example/ipsec_api/odp_ipsec_api_run_router.sh
index 31b9e7656..982a27e97 100755
--- a/example/ipsec_api/odp_ipsec_run_router.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_router.sh
@@ -3,7 +3,7 @@
 # Live router test
 #  - 2 interfaces interfaces
 #  - Specify API mode on command line
-sudo odp_ipsec -i p7p1,p8p1 \
+sudo odp_ipsec_api -i p7p1,p8p1 \
 -r 192.168.111.2/32:p7p1:08.00.27.76.B5.E0 \
 -r 192.168.222.2/32:p8p1:08.00.27.F5.8B.DB \
 -c 1 "$@"
diff --git a/example/ipsec_api/odp_ipsec_run_simple.sh b/example/ipsec_api/odp_ipsec_api_run_simple.sh
similarity index 87%
rename from example/ipsec_api/odp_ipsec_run_simple.sh
rename to example/ipsec_api/odp_ipsec_api_run_simple.sh
index ddda612a8..bdc2777c9 100755
--- a/example/ipsec_api/odp_ipsec_run_simple.sh
+++ b/example/ipsec_api/odp_ipsec_api_run_simple.sh
@@ -4,7 +4,7 @@
 #  - 2 loop interfaces
 #  - 10 packets
 #  - Specify API mode on command line
-odp_ipsec -i loop1,loop2 \
+odp_ipsec_api -i loop1,loop2 \
 -r 192.168.222.2/32:loop2:08.00.27.F5.8B.DB \
 -s 192.168.111.2:192.168.222.2:loop1:loop2:10:100 \
 -c 2 "$@"