diff --git a/example/generator/Makefile.am b/example/generator/Makefile.am
index 7deeef406..63f4ae608 100644
--- a/example/generator/Makefile.am
+++ b/example/generator/Makefile.am
@@ -3,3 +3,8 @@ include $(top_srcdir)/example/Makefile.inc
 bin_PROGRAMS = odp_generator
 
 odp_generator_SOURCES = odp_generator.c
+
+if test_example
+TESTS = generator_run.sh
+endif
+EXTRA_DIST = generator_run.sh
diff --git a/example/generator/generator_run.sh b/example/generator/generator_run.sh
new file mode 100755
index 000000000..2d741a8d1
--- /dev/null
+++ b/example/generator/generator_run.sh
@@ -0,0 +1,17 @@
+#!/bin/bash
+#
+# Copyright (c) 2018, Linaro Limited
+# All rights reserved.
+#
+# SPDX-License-Identifier:     BSD-3-Clause
+#
+
+./odp_generator${EXEEXT} -w 1 -n 1 -I null:0 -m u
+STATUS=$?
+
+if [ "$STATUS" -ne 0 ]; then
+  echo "Error: status was: $STATUS, expected 0"
+  exit 1
+fi
+
+exit 0
diff --git a/platform/linux-generic/m4/configure.m4 b/platform/linux-generic/m4/configure.m4
index 935894b8c..7fa3652e2 100644
--- a/platform/linux-generic/m4/configure.m4
+++ b/platform/linux-generic/m4/configure.m4
@@ -19,8 +19,6 @@ AM_CONDITIONAL([PLATFORM_IS_LINUX_GENERIC],
 AC_CONFIG_FILES([platform/linux-generic/Makefile
 		 platform/linux-generic/libodp-linux.pc
 		 platform/linux-generic/test/Makefile
-		 platform/linux-generic/test/example/Makefile
-		 platform/linux-generic/test/example/generator/Makefile
 		 platform/linux-generic/test/validation/api/shmem/Makefile
 		 platform/linux-generic/test/validation/api/pktio/Makefile
 		 platform/linux-generic/test/mmap_vlan_ins/Makefile
diff --git a/platform/linux-generic/test/Makefile.am b/platform/linux-generic/test/Makefile.am
index e317ff736..99934099a 100644
--- a/platform/linux-generic/test/Makefile.am
+++ b/platform/linux-generic/test/Makefile.am
@@ -3,10 +3,6 @@ TESTS_ENVIRONMENT += TEST_DIR=${top_builddir}/test/validation
 
 SUBDIRS = performance
 
-if test_example
-SUBDIRS += example
-endif
-
 if test_vald
 TESTS = validation/api/pktio/pktio_run.sh \
 	validation/api/pktio/pktio_run_tap.sh \
diff --git a/platform/linux-generic/test/example/Makefile.am b/platform/linux-generic/test/example/Makefile.am
deleted file mode 100644
index 41d287522..000000000
--- a/platform/linux-generic/test/example/Makefile.am
+++ /dev/null
@@ -1 +0,0 @@
-SUBDIRS = generator
diff --git a/platform/linux-generic/test/example/generator/Makefile.am b/platform/linux-generic/test/example/generator/Makefile.am
deleted file mode 100644
index 3bdfdc69c..000000000
--- a/platform/linux-generic/test/example/generator/Makefile.am
+++ /dev/null
@@ -1,4 +0,0 @@
-TESTS_ENVIRONMENT = EXAMPLE_DIR=${top_builddir}/example/generator
-
-TESTS = generator_run.sh
-EXTRA_DIST = generator_run.sh
diff --git a/platform/linux-generic/test/example/generator/generator_run.sh b/platform/linux-generic/test/example/generator/generator_run.sh
deleted file mode 100755
index 3e7fabfe7..000000000
--- a/platform/linux-generic/test/example/generator/generator_run.sh
+++ /dev/null
@@ -1,45 +0,0 @@
-#!/bin/bash
-#
-# Copyright (c) 2018, Linaro Limited
-# All rights reserved.
-#
-# SPDX-License-Identifier:     BSD-3-Clause
-#
-
-# directory where platform test sources are, including scripts
-TEST_SRC_DIR=$(dirname $0)
-
-# exit codes expected by automake for skipped tests
-TEST_SKIPPED=77
-
-# directories where binary can be found:
-# -in the validation dir when running make check (intree or out of tree)
-# -in the script directory, when running after 'make install', or
-# -in the validation when running standalone intree.
-# -in the current directory.
-# running stand alone out of tree requires setting PATH
-PATH="${EXAMPLE_DIR}/:$PATH"
-PATH="`pwd`/example/generator/:$PATH"
-PATH="$(dirname $0)/../../../../../example/generator:$PATH"
-PATH=".:$PATH"
-
-bin_path=$(which odp_generator${EXEEXT})
-if [ -x "$bin_path" ] ; then
-	echo "running with odp_generator: $bin_path"
-else
-	echo "cannot odp_generator: please set you PATH for it."
-	pwd
-	echo $PATH
-	exit 1
-fi
-
-
-odp_generator${EXEEXT} -w 1 -n 1 -I null:0 -m u
-STATUS=$?
-
-if [ "$STATUS" -ne 0 ]; then
-  echo "Error: status was: $STATUS, expected 0"
-  exit 1
-fi
-
-exit 0